package de.jg_cody.Teraplex.ui.Terminal;

import android.os.Bundle;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.ScrollView;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;
import androidx.lifecycle.ViewModelProvider;

import de.jg_cody.Teraplex.R;

public class TerminalFragment extends Fragment {

    public static String command;

    EditText terminal_edit_text;
    TextView terminal_textView;
    Terminal terminal;
    ScrollView scrollView;

    private TerminalViewModel terminalViewModel;

    public View onCreateView(@NonNull LayoutInflater inflater,
                             ViewGroup container, Bundle savedInstanceState) {
        terminalViewModel =
                new ViewModelProvider(this).get(TerminalViewModel.class);
        View root = inflater.inflate(R.layout.fragment_terminal, container, false);
        scrollView = (ScrollView) root.findViewById((R.id.scrollView));
        terminal_edit_text = (EditText) root.findViewById(R.id.terminal_edit_text);
        terminal_edit_text.setOnKeyListener(new View.OnKeyListener() {
            @Override
            public boolean onKey(View view, int keyCode, KeyEvent keyEvent) {
                if ((keyEvent.getAction() == KeyEvent.ACTION_DOWN) && (keyCode == KeyEvent.KEYCODE_ENTER)) {
                    terminal.sendTerminalCommand(terminal_edit_text.getText().toString());


                }
                return false;
            }
        });
        terminal_textView = (TextView) root.findViewById(R.id.terminal_textView);
        new Thread() {
            public void run() {
                terminal = new Terminal();
                while (true) {
                    try {
                        requireActivity().runOnUiThread(new Runnable() {

                            @Override
                            public void run() {
                                boolean atBottom = scrollView.getChildAt(0).getBottom() <= (scrollView.getHeight() + scrollView.getScrollY());
                                terminal_textView.setText(terminal.getTerminalOutput());
                                System.out.println(atBottom);

                                    terminal_textView.invalidate();
                                    scrollView.invalidate();
                                    scrollView.fullScroll(View.FOCUS_DOWN);

                            }
                        });
                        Thread.sleep(250);
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                }
            }
        }.start();


        return root;
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
    }
}